    ;       SD- *************
    ;  2.0  pic16f873a,     http://zvzd3d.ru/ekg
    ;
    ;   mplab ide 8.92
    ; :
    ;   CS SD-    RA5. 
    ;     AN1,  AN2,3       . 
    ;         (AN1  AN0),     
    ; (  AN2,3    ),      . 
    ;   DS1621  (   ). 
    ;      SD-  :    ,    

    list	 p=16F873a
	    
    #include p16f873a.inc
    
    ; _BODEN_OFF -    (<4)
    ; _PWRTE_ON  -  
    ; _WDT_ON    -  

    __CONFIG _CP_OFF & _DEBUG_OFF & _WRT_OFF & _CPD_OFF & _LVP_OFF & _BODEN_OFF & _PWRTE_ON & _WDT_ON & _HS_OSC
    
    RADIX dec
    
    EXPAND    
 
    ERRORLEVEL 0, -305, -302
    
    ; **********************************************************************************************
    ;   ( 256 )    (),   
    ;     RS-232,        
    ;    RS-232        
    ;
    ;    : 
    ;      57.6 /   10 
    ;      0.1     0xcd -   
    ;     0xcd -       
    ;   0xcd, 0xe6, AdrLo, AdrHi -  ROM 
    ;   0xcd, 0xe7, AdrLo, AdrHi, DataLo, DataHi -   ROM 
    ;   0xcd, 0xe8, Adr -  flash 
    ;   0xcd, 0xe9, Adr, Data -  flash 
    ;   0xcd, 0xeb -   
    
    cblock 0x20
        ;  
        ;         
        ; (    Monitor_DetectMemoryCmd)
        OutByte
        CanCont
    endc

    org 0x0
    ;
    ;    
    ;
STARTER_ENTRY_POINT:
    clrf INTCON
    clrf STATUS
	clrf PCLATH
    goto STARTER_ENTRY_POINT_CONTINUE
    ;goto USER_CODE_ENTRY_POINT
    ;
    ;
    ;  
    org 4
    goto USER_CODE_IRQ
    goto $
    goto $
    goto $
    ;
    ;
    ;    
    ;         
    ;
    org 8
    ;
Usart_Init:   goto __Usart_Init
Usart_In_WDT: clrwdt
Usart_In:     goto __Usart_In
Usart_Out:    goto __Usart_Out
Mem_ReadROM:  goto __Mem_ReadROM
Mem_ReadFlash:  goto __Mem_ReadFlash
Mem_WriteFlash_Wait:  goto __Mem_WriteFlash_Wait
Mem_WriteFlash_Write: goto __Mem_WriteFlash_Write
Monitor_DetectMemoryCmd: goto __Monitor_DetectMemoryCmd
    ;
    ;
STARTER_ENTRY_POINT_CONTINUE:
    ;
    ;    
    bsf STATUS, RP0
	movlw b'11111111'
	movwf TRISA
	movwf TRISB
	movwf TRISC
    movlw b'11001101'; .., WDT  1:32,  0.3 - 0.6 - 1.2 
	movwf OPTION_REG
    bcf STATUS, RP0
    ;
    ;   ,  
    clrf T1CON
    clrf T2CON
    clrf CCP1CON
    clrf CCP2CON
    clrf SSPCON
    ;
    ;  Usart
    call Usart_Init
    ;
    clrf CanCont
    movlw 0x55
    movwf OutByte
    ;
MainLoop:
    movlw 200
    call Usart_In_WDT
    btfsc STATUS, C
    goto MainLoop_NoData
    sublw 0xcd
    btfsc STATUS, Z
    goto MaimLoop_CMD
    sublw 0xcd
    call Usart_Out
    goto MainLoop
    ;
MainLoop_NoData:
    btfss CanCont, 0
    goto User_Start
    movf OutByte, w
    incf OutByte
    call Usart_Out
    goto MainLoop
    ;
User_Start:
    movlw 0xbb
    call Usart_Out
    clrwdt
    goto USER_CODE_ENTRY_POINT
    ;
    ;
    ;     
MaimLoop_CMD:
    bsf CanCont, 0
    call MainLoop_GetByte
    btfsc STATUS, C
    goto MainLoop
    movwf FSR
    sublw 0xeb
    btfsc STATUS, Z
    goto User_Start
    movf FSR, w
    call Monitor_DetectMemoryCmd
    goto MainLoop
    ;
    ;
    ;  0.1   c Usart    
MainLoop_GetByte:
    bcf STATUS, RP0
    bcf STATUS, RP1
    movlw 200
    goto Usart_In_WDT
    ;
    ;       
    ;  : W -      
    ;    ,       Usart
    ;  FSR
    ;
__Monitor_DetectMemoryCmd:
    movwf FSR
    movlw 0xe6
    subwf FSR, w
    btfsc STATUS, Z
    goto MaimLoop_CMD_ReadROM
    movlw 0xe7
    subwf FSR, w
    btfsc STATUS, Z
    goto MaimLoop_CMD_WriteROM
    movlw 0xe8
    subwf FSR, w
    btfsc STATUS, Z
    goto MaimLoop_CMD_ReadFlash
    movlw 0xe9
    subwf FSR, w
    btfsc STATUS, Z
    goto MaimLoop_CMD_WriteFlash
    return
    ;
    ;
MaimLoop_CMD_ReadROM:
    call MainLoop_GetByte
    btfsc STATUS, C
    return
    bsf STATUS, RP1
    movwf EEADR
    call MainLoop_GetByte
    btfsc STATUS, C
    return
    bsf STATUS, RP1
    movwf EEADRH
    ;
    call Mem_ReadROM
    ;
    call Usart_Out
    bsf STATUS, RP1
    movf EEDATH, w
    bcf STATUS, RP1
    goto Usart_Out
    ;
    ;
    ;   
    ;   EEADRH:EEADR (0x10f:0x10d)-  ,  - 
    ;   EEDATH::EEDATA (0x10e:0x10c) -  
    ;   W=EEDATA,     
    ;
__Mem_ReadROM:
    bsf STATUS, RP1
    bsf STATUS, RP0
    bsf EECON1, EEPGD
    bsf EECON1, RD
    nop
    nop
    bcf STATUS, RP0
    movf EEDATA, w
    bcf STATUS, RP1
    return
    ;
MaimLoop_CMD_ReadFlash:
    call MainLoop_GetByte
    btfsc STATUS, C
    return
    call Mem_ReadFlash
    goto Usart_Out
    ;
    ;
    ;  flash - 
    ;   W -  ,  - 
    ;   EEDATA (0x10c) -  
    ;   W=EEDATA,     
__Mem_ReadFlash:
    bcf STATUS, RP0
    bsf STATUS, RP1
    movwf EEADR
Mem_ReadFlash_Proc: ; ,     EEADR (0x10d),  - 
    bsf STATUS, RP1
    bsf STATUS, RP0
    bcf EECON1, EEPGD
    bsf EECON1, RD
    bcf STATUS, RP0
    movf EEDATA, w
    bcf STATUS, RP1
    return;    
    ;
MaimLoop_CMD_WriteROM:
    call MainLoop_GetByte
    btfsc STATUS, C
    return
    bsf STATUS, RP1
    movwf EEADR
    call MainLoop_GetByte
    btfsc STATUS, C
    return
    bsf STATUS, RP1
    movwf EEADRH
    call MainLoop_GetByte
    btfsc STATUS, C
    return
    bsf STATUS, RP1
    movwf EEDATA
    call MainLoop_GetByte
    btfsc STATUS, C
    return
    bsf STATUS, RP1
    movwf EEDATH
    ;    
    movf EEADRH, w
    btfss STATUS, Z;  !!!, btfsc -     !!!
    goto MaimLoop_CMD_WriteROM_WR
    movf EEADR, w
    addlw -4
    sublw 3
    btfss STATUS, C
    goto MaimLoop_CMD_WriteIgnore
MaimLoop_CMD_WriteROM_WR:
    bsf STATUS, RP0
    bsf EECON1, EEPGD
    bsf EECON1, WREN
    movlw 0x55
    movwf EECON2
    movlw 0xaa
    movwf EECON2
    bsf EECON1, WR
    nop
    nop
    bcf EECON1, WREN
    bcf STATUS, RP0
    bcf STATUS, RP1
    ;
MaimLoop_CMD_WriteOK:
    movlw 0xAA
    goto Usart_Out
    ;
MaimLoop_CMD_WriteIgnore:
    bcf STATUS, RP0
    bcf STATUS, RP1
    movlw 0xEE
    goto Usart_Out
    ;
MaimLoop_CMD_WriteFlash:
    call MainLoop_GetByte
    btfsc STATUS, C
    return
    call Mem_WriteFlash_Wait
    bsf STATUS, RP1
    movwf EEADR
    call MainLoop_GetByte
    btfsc STATUS, C
    return
    bsf STATUS, RP1
    movwf EEDATA
    goto Mem_WriteFlash_Write
    ;
    ;
    ;
    ;     flash - 
    ;   -  
    ;   -  ,     
    ;      EEADR  EEDATA ()
    ;
__Mem_WriteFlash_Wait:
    bsf STATUS, RP0
    bsf STATUS, RP1
    btfsc EECON1, WR
    goto $-1
    bcf STATUS, RP0
    bcf STATUS, RP1
    return
    ;
    ;   flash - 
    ;      Mem_WriteFlash_Wait
    ;   EEADR  (0x10d) -  ,
    ;          EEDATA (0x10c) -   
    ;           - 
    ;    , W ,    (!)
    ;
__Mem_WriteFlash_Write:
    bsf STATUS, RP0
    bsf STATUS, RP1
    bcf EECON1, EEPGD
    bsf EECON1, WREN
    bcf INTCON, GIE
    movlw 0x55
    movwf EECON2
    movlw 0xaa
    movwf EECON2
    bsf EECON1, WR
    bcf EECON1, WREN
    bcf STATUS, RP0
    bcf STATUS, RP1
    return
    ;
    ;
    ;    Usart
    ;    ,   - 
    ;
__Usart_Init:
    ;   USART
    bsf STATUS, RP0
    bcf STATUS, RP1
    clrf TXSTA
    movlw b'10100111'
    movwf TXSTA
    movlw 10
    movwf SPBRG
    bcf STATUS, RP0
    ;
    ;   USART ( )
    clrf RCSTA
    movlw b'10010000'
    movwf RCSTA
    return
    ;
    ;   W.   
    ;                  ,    
    ;
__Usart_Out:
    btfss PIR1, TXIF
    goto __Usart_Out
    movwf TXREG
    return
    ;
    ;  
    ; :  W -  -    0.5 
    ;        ,    
    ; : W -  , C==1,     TimeOut
    ;         FSR ,  -  !
__Usart_In:
    movwf FSR
Usart_In_L1:
    movlw 156
Usart_In_L2:
    btfss RCSTA, OERR
    goto Usart_In_noReset
    ;call Usart_In_Reset
    ;bcf STATUS, C
    ;btfsc RCSTA, FERR
    ;bsf STATUS, C
    ;movf RCREG, w
    bcf RCSTA, CREN
    bsf RCSTA, CREN
Usart_In_noReset:
    btfsc PIR1, RCIF
    goto Usart_In_End
    addlw 0xff
    btfss STATUS, Z
    goto Usart_In_L2
    decfsz FSR
    goto Usart_In_L1
    bsf STATUS, C
    return
    ;
Usart_In_End:
    bcf STATUS, C
    btfsc RCSTA, FERR
    bsf STATUS, C
    movf RCREG, w
    return
    ;
    ;
    ;
    ;
    ;
    ; *****************************************************************************************************************************************************
    ; *****************************************************************************************************************************************************
    ; **********************      ****************************************************************
    ; *****************************************************************************************************************************************************
    ; *****************************************************************************************************************************************************
    ;
    ;
    ;
    ;
    ;    I2C
    ;
IC2DataBit equ 6           
IC2SyncBit equ 7
I2CPORT    equ PORTB  ;        ,
I2CTRIS    equ TRISB  ;  I2C   
    ;
    ;
    ;
    ;    SD / MMC 
    ;
CMD0_GO_IDLE_STATE        equ 0x40 + 0
CMD8_SEND_IF_COND         equ 0x40 + 8
CMD55_APP_CMD             equ 0x40 + 55
CMD58_READ_OCR            equ 0x40 + 58
ACMD41_SD_SEND_OP_COND    equ 0x40 + 41
CMD17_READ_SINGLE_BLOCK   equ 0x40 + 17
CMD18_READ_MULTY_BLOCK    equ 0x40 + 18
CMD12_STOPREAD            equ 0x40 + 12
CMD24_WRITE_BLOCK         equ 0x40 + 24
CMD25_WRITE_MULTY_BLOCK   equ 0x40 + 25
    ;
    ;
    ;
    ;   MMC_Init_Status -   SD-
    ;
MMCINIT_SD2               equ 0  ;   ,    SD >= 2.0
MMCINIT_HC                equ 1  ;   ,  SD HC
MMCINIT_INITOK            equ 2  ;   ,   SD  
MMCINIT_CANWRITE          equ 3  ;   ,  SD     
    ;
    ;
    ;
    ;   ""  SD - : 
    ; ,           EmptyPos
    ;      EmptyPos  flash  
    ;   .    ""       
    ;    ! 
    ; 
FILE_GRANULA              equ 4;   4    1  -
    ;
    ;
    ;
    cblock 0x20
        ;   USERa
        ;        
        WaitST;           ,     FSR    
        IntProc_Temp1
        ;
        IntProc_Temp2    
        IntProc_FSR            
        ;
        MMC_Init_Status;    SD-
        ;
        MMC_Adr: 4
        ReadMMCSize
        ReadMMCSpeed
        ;
        MMCWriteCmdR1
        MMCWriteDataRespToken        
        ;
        ;
        Shim_ST;       
        SysTime:4;      
        ;
        ACP_BufPos
        ACP_NNN
        ACP_Sum: 2
        ;
        ACP_ReadPos
        ;
        TH_Config
        TH_Temperature:2
        TH_Counter
        TH_Slope
        ;
        I2C_Adress
        I2C_DataByte
        I2C_OutBitST
        I2C_Error
        ;
        DS1621_Cmd
        DS1621_Byte0
        DS1621_Byte1
        DS1621_Byte2
        ;
        CH2_N    
        CH2_Lo
        CH2_Hi
        ;
        Locked_Value: 0
        Locked_L
        Locked_H
        TMR1_B2
        TMR1_B3
        ;
        LockAct
        ;
        NewLock_T0: 4
        NewLock_S: 4
        NewLock_N: 4
        ;
        NewLockRes_T0: 4
        NewLockRes_S: 4
        NewLockRes_N: 4
        ;
        ;
        ;WAVE_WritePos
        ;WAVE_ReadPos
        ;WAVE_PlayValue        
        ;
        XOUT:2 
        YOUT:2
        ZOUT:2
        XYZN
        ;
        EmptyPos: 4
        EmptyPosCode: 4
        ;
        ;OldFile_StartAdr:4    
        File_StartAdr:4
        ;File_WritedAdr:4
        
        NakMode: 1
    endc
    ;
    ; *********************************************************************
    ;   
    cblock 0x20+0x80;   
        ;
        WaitST__;      
        IntProc_Temp1__        
        ACP_MemoryBuffer:0 ;     0xff]
        WAVE_MemoryBuffer:0 ;       WAVE
    endc
    ;   
    ;
;    ;     32-   512
;SADD512 macro Value
;    local SADD512_EXIT
;    movlw 2
;    addwf Value+1
;    btfss STATUS, C
;    goto SADD512_EXIT
;    incfsz Value+2
;    goto SADD512_EXIT
;    incfsz Value+3
;    goto SADD512_EXIT
;    incf Value+3;   
;SADD512_EXIT:
;    endm
    ;
    ;
    ;
    ;
WAIT2 macro
    goto $+1
    endm
    ;
WAIT3 macro
    nop
    goto $+1
    endm
    ;
WAIT4 macro
    call WAIT4T
    endm
    ;
WAIT5 macro
    call WAIT5T
    endm
    ;
WAIT6 macro
    call WAIT6T
    endm
    ;
    ;   32- 
INC32M macro Value
    local INC32M_EXIT
    incfsz Value 
    goto INC32M_EXIT
    incfsz Value+1
    goto INC32M_EXIT
    incfsz Value+2
    goto INC32M_EXIT
    incfsz Value+3
    nop
INC32M_EXIT:
    endm 
    ;
    ;   32-   Src  Dest
MOVE32M macro Dest, Src
    movf Src, w     ;   
    movwf Dest
    movf Src+1, w
    movwf Dest+1
    movf Src+2, w
    movwf Dest+2
    movf Src+3, w
    movwf Dest+3
    endm    
    ;
    ;   16-  Arg1 = Arg1 + Arg2
ADD16M macro Arg1, Arg2 
    movf Arg2, w
    addwf Arg1
    ;
    movf Arg2+1, w
    btfsc STATUS, C
    incfsz Arg2+1, w
    addwf Arg1+1
    ;
    endm
    ;
    ;       16-   Arg1 = Arg1 + (Arg2+128)
ADD16SigB macro Arg1, Arg2 
    movf Arg2, w
    addlw 128
    addwf Arg1
    btfsc STATUS, C
    incf Arg1+1
    endm
    ;
    ;   32- 
CLR32M macro Value
    clrf Value
    clrf Value+1
    clrf Value+2
    clrf Value+3
    endm
    ;
    ;   16- 
CLR16M macro Value
    clrf Value
    clrf Value+1
    endm
    ;
    ;
    ;   32-  Arg1 = Arg1 + Arg2
ADD32M macro Arg1, Arg2 
    movf Arg2, w
    addwf Arg1
    ;
    movf Arg2+1, w
    btfsc STATUS, C
    incfsz Arg2+1, w
    addwf Arg1+1
    ;
    movf Arg2+2, w
    btfsc STATUS, C
    incfsz Arg2+2, w
    addwf Arg1+2
    ;
    movf Arg2+3, w
    btfsc STATUS, C
    incfsz Arg2+3, w
    addwf Arg1+3
    ;
    endm
    ;
    ;   32-  Arg1 = Arg1 - Arg2
SUB32M macro Arg1, Arg2 
    movf Arg2, w
    subwf Arg1
    ;
    movf Arg2+1, w
    btfss STATUS, C
    incfsz Arg2+1, w
    subwf Arg1+1
    ;
    movf Arg2+2, w
    btfss STATUS, C
    incfsz Arg2+2, w
    subwf Arg1+2
    ;
    movf Arg2+3, w
    btfss STATUS, C
    incfsz Arg2+3, w
    subwf Arg1+3
    ;
    endm
    ;
    ;
    ;  32- ,  C  Z . ,   Arg1 = Arg1 - Arg2
CMP32M macro Arg1, Arg2
    local CMP32M_EXIT
    movf Arg2+3, w
    subwf Arg1+3, w
    btfss STATUS, Z
    goto CMP32M_EXIT
    movf Arg2+2, w
    subwf Arg1+2, w
    btfss STATUS, Z
    goto CMP32M_EXIT
    movf Arg2+1, w
    subwf Arg1+1, w
    btfss STATUS, Z
    goto CMP32M_EXIT
    movf Arg2, w
    subwf Arg1, w
CMP32M_EXIT:
    endm
    ;
    ;
    ;  32-     
COM32M macro Arg32
    comf Arg32
    comf Arg32+1
    comf Arg32+2
    comf Arg32+3
    endm
    ;
    ;    
XORL32M macro Arg32, ConstValue
    movlw (ConstValue)
    xorwf Arg32
    movlw (ConstValue)>>8
    xorwf Arg32+1
    movlw (ConstValue)>>16
    xorwf Arg32+2
    movlw (ConstValue)>>24
    xorwf Arg32+3
    endm
    ;
    ;
JC  macro Label
    btfsc STATUS, C
    goto Label
    endm
    ;
JNC macro Label
    btfss STATUS, C
    goto Label
    endm
    ;
JZ  macro Label
    btfsc STATUS, Z
    goto Label
    endm
    ;
JNZ macro Label
    btfss STATUS, Z
    goto Label
    endm
    ;
    ;
    ;
    ; ************  ( )      ************
    ;
    ;        TMR1
IRQINCTMR1HI macro 
    bcf PIR1, TMR1IF    
    incfsz TMR1_B2
    goto $+2
    incf TMR1_B3
    endm
    ;
    ;
    ;
    ;     USART 16-  (  Streem_OutByte)
Streem_OutWORD macro Value16
    movf Value16, w
    call Streem_OutByte
    movf Value16+1, w
    call Streem_OutByte
    endm
    ;
    ;     USART 32-  (  Streem_OutByte)
Streem_OutDWORD macro Value32
    movf Value32, w
    call Streem_OutByte
    movf Value32+1, w
    call Streem_OutByte
    movf Value32+2, w
    call Streem_OutByte
    movf Value32+3, w
    call Streem_OutByte
    endm
    ;
    ;
    ;   Value  CodeValue    
EmptyPosCoderM macro CodeValue, Value
    bcf STATUS, C
    rrf Value+3, w
    xorwf Value+3, w
    movwf CodeValue+3
    rrf Value+2, w
    xorwf Value+2, w
    movwf CodeValue+2
    rrf Value+1, w
    xorwf Value+1, w
    movwf CodeValue+1
    rrf Value+0, w
    xorwf Value+0, w
    movwf CodeValue+0
    endm
    ;
    ;
    ;   Value  CodeValue      CodeValue:
    ; NChange -   ,  FSR -    .
    ;   EmptyPosCode,  FILE_GRANULA,   ,
    ;    ,       .
    ; 
EmptyPosCodeAndTestChangeM macro CodeValue, Value, NChange
    local L3_NoCh, L2_NoCh, L1_NoCh, L0_NoCh
    bcf STATUS, C
    clrf NChange
    rrf Value+3, w
    xorwf Value+3, w
    xorwf CodeValue+3, w
    JZ L3_NoCh
    xorwf CodeValue+3
    incf NChange
    movlw 3
    movwf FSR
L3_NoCh:
    rrf Value+2, w
    xorwf Value+2, w
    xorwf CodeValue+2, w
    JZ L2_NoCh
    xorwf CodeValue+2
    incf NChange
    movlw 2
    movwf FSR
L2_NoCh:
    rrf Value+1, w
    xorwf Value+1, w
    xorwf CodeValue+1, w
    JZ L1_NoCh
    xorwf CodeValue+1
    incf NChange
    movlw 1
    movwf FSR
L1_NoCh:
    rrf Value+0, w
    xorwf Value+0, w
    ;
    xorwf CodeValue+0      ;    [CodeValue+0] <-> W
    xorwf CodeValue+0, w
    xorwf CodeValue+0
    ;
    xorwf CodeValue+0, w   ;      FILE_GRANULA
    movf NChange
    btfss STATUS, Z
    andlw 0xff - (FILE_GRANULA-1);    ,   (FILE_GRANULA) 
    andlw 0xff
    JZ L0_NoCh
    incf NChange
    clrf FSR
L0_NoCh:
    endm
    ;
    ;
    ;
    org 0x100
    ;
USER_CODE_ENTRY_POINT:
    ;
    clrwdt
    ;
    clrf INTCON
    clrf STATUS
    clrf PCLATH
    ;
    movlw 0xcc
    call Usart_Out
    movlw 0xdd
    call Usart_Out
    movlw 0xee
    call Usart_Out
    movlw 0xff
    call Usart_Out
    ;
    ;
    clrf PORTA
    clrf PORTC
    bsf PORTA, 5
    bsf PORTC, 0
    clrf PORTB
    ;
    bsf STATUS, RP0
    movlw b'01001111'
    movwf OPTION_REG;   
    movlw b'11111111'
    movwf TRISB;  
    movwf TRISA 
    bsf TRISC, 0
    bcf TRISC, 3
    bsf TRISC, 4
    bcf TRISC, 5
    bsf TRISC, 2
    bcf TRISA, 5
    bsf TRISC, 6
    bsf TRISC, 7
    bcf STATUS, RP0
    ;
    movlw b'00000000'
    movwf INTCON;  
    ;
    ;  MSSP
    bsf STATUS, RP0
    bcf STATUS, RP1    
    movlw b'00000000'
    movwf SSPSTAT
    bcf STATUS, RP0
    bcf STATUS, RP1    
    movlw b'00110000'; Fosc/4
    ;movlw b'00110001'; Fosc/16
    movwf SSPCON    
    ;
    ;     
    clrf NakMode
    ;
    ;movlw b'01000001'; 01 - Fosc/8, 000 -  , GO=0, XXX=0, ADON = 1 ( )
    movlw b'01001001'; 01 - Fosc/8, 000 -  , GO=0, XXX=0, ADON = 1 ( )
    movwf ADCON0
    bsf STATUS, RP0
    ;movlw b'10001110'; D7 D6 D5 D4 D3 D2 D1 A
    ;movlw b'10000000'; A7 A6 A5 A4 A3 A2 A1 A0
    movlw b'10001101'; D7 D6 D5 D4 Vref+ Vref- A1 A0; 2016_12_30 -  VRef
    movwf ADCON1; D7 -  , D6-4 - , D3-0 -  
    bcf STATUS, RP0
    ;clrf ACP_BufPos
    ;clrf ACP_ReadPos
    ;movlw -5
    ;movwf ACP_NNN    
    ;
    ;;  
    ;movlw b'00000000'       
    ;movwf T1CON; TMR1
    ;movlw b'00001100'
    ;movwf T2CON
    ;movlw b'00001100'
    ;movwf CCP1CON 
    ;movlw b'00000000'
    ;movwf CCP2CON 
    ;; 
    ;bsf STATUS, RP0
    ;movlw 0x3f
    ;movwf PR2;   2
    ;bcf STATUS, RP0
    ;
;    movlw ACP_MemoryBuffer
;    movwf FSR
;SH_Init:
;    movf FSR, w
;    movwf INDF
;    incfsz FSR
;    goto SH_Init
    ;
    ;
    movlw b'00000101'
    movwf T1CON;   
    ;
    movlw b'00000000'
    movwf CCP1CON
    ;movlw b'00000111';  16- 
    movlw b'00000101';   
    movwf CCP1CON;    
    ;
    clrf TMR1H    
    clrf TMR1L
    clrf TMR0
    ;
    call I2C_Stop
    ;
    ;    
    ;  
    call MMC_Init
    ;
    ;goto NewLoop
    ;
    ;
    call ReadEmptyPosFromEEPROM     ;   EEPROM  EmptyPosCode    EmptyPos
    ;
    MOVE32M File_StartAdr, EmptyPos ;       
    ;
    clrf Shim_ST
    clrf SysTime
    clrf SysTime+1
    clrf SysTime+2
    clrf SysTime+3
    ;    
    bsf STATUS, RP0
    movlw b'01000000'
    movwf PIE1
    movlw b'00000000'
    movwf PIE2
    bcf STATUS, RP0    
    movlw b'11000000'
    movlw 0
    movwf INTCON
    
    ;goto NewLoop    
    
    movlw b'11100000'
    movwf INTCON
    ;
    ;
    ;
    call StartMMCBlockWrite
    ;
MainWriteLoop:
    clrwdt;      SD-,      
    ;
    ; ,      
    call TestStopCommand
    btfsc STATUS, Z
    goto MainWriteLoop_Exit
    ;
    btfss MMC_Init_Status, MMCINIT_CANWRITE
    goto MainWriteLoop_NoChangeFlash    
    ;
    movf EmptyPos+0, w;   ,     EEPROM   EmptyPos
    andlw (FILE_GRANULA-1)
    JNZ MainWriteLoop_NoChangeFlash
    ;
    ;  EmptyPos  EmptyPosCode   :  WaitST   ,  FSR -
    ;   (   EmptyPosCode   FILE_GRANULA  )
    ; 
    EmptyPosCodeAndTestChangeM EmptyPosCode, EmptyPos, WaitST
    movf WaitST, w
    JZ MainWriteLoop_NoChangeFlash
    decfsz WaitST, w
    goto MainWriteLoop_CoderFatalErr
    ;
    ;  FSR -      EmptyPosCode
    ;       flash  
    ;
    movf FSR, w;                      EEPROM   c  
    call Eeprom_Write_Set_EEADR;         flash 
    movf FSR, w;                    ( FILE_GRANULA,    )
    addlw EmptyPosCode
    movwf FSR
    movf INDF, w
    ;
    bsf STATUS, RP1;       flash-     EmptyPosCode
    movwf EEDATA;       (  ,  FILE_GRANULA,   )
    bsf STATUS, RP0
    bcf EECON1, EEPGD
    bsf EECON1, WREN
    bcf INTCON, GIE
    movlw 0x55
    movwf EECON2
    movlw 0xaa
    movwf EECON2
    bsf EECON1, WR
    bsf INTCON, GIE;        -   !
    bcf EECON1, WREN
    clrf STATUS
    ;
MainWriteLoop_NoChangeFlash:
    ;
    ;call Termo_Read;   
    ;
    btfsc MMC_Init_Status, MMCINIT_CANWRITE
    call MMC_OnCS_WaitEndOfWrite    
    ;
    ;    - Start Block Token
    movlw 0xfc
    call Streem_OutMMC
    ;
    ;    
    ;
    movlw 0xaa;              
    call Streem_OutByte
    movlw 0x55;      
    call Streem_OutByte
    movlw 0x39;      
    call Streem_OutByte
    movlw 0xa7;      
    call Streem_OutByte
    ;
    Streem_OutDWORD File_StartAdr   ;       
    Streem_OutDWORD EmptyPos        ;     
    ;
    movf SysTime+0, w;       
    call Streem_OutByte
    movf SysTime+1, w
    call Streem_OutByte
    movf SysTime+2, w
    call Streem_OutByte
    movf SysTime+3, w
    call Streem_OutByte
    ;
    ;
    movf TH_Config, w;    
    call Streem_OutByte
    movf TH_Temperature, w
    call Streem_OutByte
    movf TH_Temperature+1, w 
    call Streem_OutByte
    movf TH_Counter, w
    call Streem_OutByte
    movf TH_Slope, w
    call Streem_OutByte
    movf I2C_Error, w
    call Streem_OutByte    
    ;
    movf CH2_Lo, w;        
    call Streem_OutByte
    movf CH2_Hi, w
    call Streem_OutByte    
    ;
    clrf CH2_Lo;              CH2
    clrf CH2_Hi
    clrf CH2_N    
    ;
    Streem_OutDWORD  NewLockRes_T0;      T0, S, N
    Streem_OutDWORD  NewLockRes_S
    Streem_OutDWORD  NewLockRes_N
    bsf LockAct, 0;              CCP
    ;
    ;
    Streem_OutWORD XOUT;        7455LT
    Streem_OutWORD YOUT
    Streem_OutWORD ZOUT
    movf I2C_Error, w
    call Streem_OutByte    
    movf XYZN, w
    call Streem_OutByte    
    CLR16M XOUT;                  7455LT
    CLR16M YOUT
    CLR16M ZOUT
    clrf XYZN
    ;
    ;
    movlw 256-8-3-1-6 - 4;          
    movwf WaitST    
MainWriteLoop_OutLoop:
    ;
Wait_ACP_Data:
    movf ACP_ReadPos, w
    subwf ACP_BufPos, w
    btfss STATUS, Z
    goto Wait_ACP_DataReady
    ;
    ;    -        MMA7455LT
    ; 
    btfsc XYZN, 7
    goto Wait_ACP_Data;     
    movlw 0x1d * 2
    movwf I2C_Adress    
    clrf I2C_Error  
    call MMA7455_Init
    call MMA7455_GetStatus
    btfss DS1621_Byte0, 0
    goto Wait_ACP_Data;         
    call MMA7455_Read8
    ADD16SigB XOUT, DS1621_Byte0
    ADD16SigB YOUT, DS1621_Byte1
    ADD16SigB ZOUT, DS1621_Byte2
    incf XYZN
    goto Wait_ACP_Data
    ;
Wait_ACP_DataReady:
    movf ACP_ReadPos, w
    andlw 0xfe
    movwf FSR
    movf INDF, w
    call Streem_OutByte
    incf FSR
    movf INDF, w
    call Streem_OutByte
    incfsz FSR, w
    goto $+2
    movlw ACP_MemoryBuffer
    movwf ACP_ReadPos
    decfsz WaitST
    goto MainWriteLoop_OutLoop
    ;
    call Streem_OutMMC;    - CRC
    call Streem_OutMMC
    ;
    ;     SD-: < ,   CMD25, Data Response Token>
    movf MMC_Init_Status, w
    call Usart_Out
    movf MMCWriteCmdR1, w
    call Usart_Out
    movf MMCWriteDataRespToken, w
    call Usart_Out
    ;    
    btfss MMC_Init_Status, MMCINIT_CANWRITE
    goto MainWriteLoop
    ;
    ;
    call SPI_ReadByte       ;    SD -       
    movwf FSR
    andlw 0x1f
    sublw 0x5
    btfsc STATUS, Z
    goto MainWriteLoop_WrOK   
    ; 
    ;       SD/MMC - 
    movf FSR, w             
    movwf MMCWriteDataRespToken   ;      
    ;
    bcf  MMC_Init_Status, MMCINIT_CANWRITE
    ;
    movlw CMD12_STOPREAD    ;         
    call MMC_Cmd 
    call MMC_OffCS          ;   SD-
    ;
    ;goto MainWriteLoop
    goto 0; 2017.01.30 -  ,     
    ;
MainWriteLoop_WrOK:
    INC32M EmptyPos
    goto MainWriteLoop
    ;
    ;
    ;
    ;
Streem_OutByte:
    call Usart_Out
Streem_OutMMC:
    btfsc MMC_Init_Status, MMCINIT_CANWRITE
    goto SPI_OutByte
    return
    ;
    ;
    ;  SD-        EmptyPos
    ;   ,   MMC_Init_Status   MMCINIT_CANWRITE
    ;    (CS=0)
    ;
StartMMCBlockWrite:
    movlw 0xff
    movwf MMCWriteCmdR1
    movwf MMCWriteDataRespToken
    bcf MMC_Init_Status, MMCINIT_CANWRITE
    ;
    btfss MMC_Init_Status, MMCINIT_INITOK
    return                                   ;  SD-  
    ;
    movf EmptyPos+2, w
    iorwf EmptyPos+3, w
    btfsc STATUS, Z
    return                                   ;    < 65536,   
    ;
    MOVE32M MMC_Adr, EmptyPos
    btfsc MMC_Init_Status, MMCINIT_HC
    goto StartMMCBlockWrite_UseHCAddres
    ;    
    clrf MMC_Adr+0                           ;    HC -      
    bcf STATUS, C
    rlf EmptyPos+0, w
    movwf MMC_Adr+1
    rlf EmptyPos+1, w
    movwf MMC_Adr+2
    rlf EmptyPos+2, w
    movwf MMC_Adr+3
    btfsc STATUS, C
    return                                   ;     
    movf EmptyPos+3, w
    btfss STATUS, Z
    return                                   ;     
    ;
StartMMCBlockWrite_UseHCAddres:
    ;    
    call MMC_OnCS_WaitEndOfWrite    
    movlw CMD25_WRITE_MULTY_BLOCK
    call MMC_Cmd
    movwf MMCWriteCmdR1
    sublw 0
    btfss STATUS, Z
    goto MMC_OffCS                            ;     
    ;
    bsf MMC_Init_Status, MMCINIT_CANWRITE     ;   -      
    return
    ;
    ;
    ;  , SD- 
EndMMCBlockWrite: 
    btfss MMC_Init_Status, MMCINIT_CANWRITE
    return
    bcf MMC_Init_Status, MMCINIT_CANWRITE
    call MMC_OnCS_WaitEndOfWrite    
    movlw 0xfd;       Stop Tran Token
    call SPI_OutByte
    goto MMC_OffCS
    ;
    ;
MainWriteLoop_CoderFatalErr:
    ;   EmptyPos  EmptyPosCode    
    ;
    call EndMMCBlockWrite;       
    ;
    clrf MMCWriteCmdR1;            ( )
    movlw 5
    movwf MMCWriteDataRespToken
    ;    
    goto MainWriteLoop_NoChangeFlash
    ;
    ;
MainWriteLoop_Exit:
    call EndMMCBlockWrite  ;    SD-,    
    ;
    bsf STATUS, RP1        ;      EmptyPosCode  EEPROM 
    bsf STATUS, RP0;   
    btfsc EECON1, WR  
    goto $-1
    clrf STATUS
    ;
    goto EnterNewLoop
    ;
    ; 
    ;       *********************************************
    ;        ,      
    ;      STOP     .
    ;      STOP      ,     
    ;     ,       
    ;
EnterNewLoop:
    clrf INTCON
    call StopCommandSendUsart    
NewLoop:

;    bsf PORTC, 0
;    bsf STATUS, RP0
;    bcf TRISC, 0
;    bcf TXSTA, 5
;    bcf STATUS, RP0
;NewLoop__:    
;    incf InValue
;    movf InValue,w
;    call FastOut921600
;    nop
;    nop
;    nop
;    nop
;    clrwdt
;    goto NewLoop__


    ;call Termo_Read
    ;bcf INTCON, GIE
    ;incf FastOut_x
    ;movf FastOut_x, w
    ;movwf FSR
    ;call FastOut
    ;bsf INTCON, GIE
    ;
    movlw 100
    call Usart_In_WDT
    btfsc STATUS, C
    goto NewLoop
    sublw 0xcd        
    btfss STATUS, Z
    goto NewLoop
    movlw 100
    call Usart_In_WDT
    btfsc STATUS, C
    goto NewLoop
    movwf FSR
    sublw 12
    btfsc STATUS, Z
    goto CMD1
    movf FSR,w
    sublw 13
    btfsc STATUS, Z
    goto CMD2
    movf FSR,w
    sublw 23
    btfsc STATUS, Z
    goto CMD4
    movf FSR,w
    sublw 25
    btfsc STATUS, Z
    goto CMD5
    movf FSR,w
    sublw 11
    btfsc STATUS, Z
    goto EnterNewLoop
    movf FSR,w
    sublw 16
    btfsc STATUS, Z
    goto CMD3
    movf FSR,w
    sublw 34
    btfsc STATUS, Z
    goto CMDE_ReadEmptyPos
    movf FSR,w
    sublw 35
    btfsc STATUS, Z
    goto CMDE_WriteEmptyPos
    ;movf FSR,w
    ;sublw 27
    ;btfsc STATUS, Z
    ;goto CMD7
    movf FSR,w
    sublw 10
    btfsc STATUS, Z
    goto 0
    ;
    movlw 0xee
    call Usart_Out
    goto NewLoop
    ;
    ;
CMD3:    
    call MMC_Init
    goto NewLoop
    ;
    ;
    ;
    ;   Usart 4    
    ;
CMDs_WaitUsartAdr:
    movlw 200
    call Usart_In_WDT
    btfsc STATUS, C
    return
    movwf MMC_Adr+0
    movlw 200
    call Usart_In_WDT
    btfsc STATUS, C
    return
    movwf MMC_Adr+1
    movlw 200
    call Usart_In_WDT
    btfsc STATUS, C
    return
    movwf MMC_Adr+2
    movlw 200
    call Usart_In_WDT
    movwf MMC_Adr+3
    return
    ;
    ;
    ;        
    ;        
    ;    0xfe,      , 
    ;   R1  Data Error Token,    .
    ;    512,  CRC   0xaa, 0x79
CMD1:
    ;
    ;   Usart 4     
    call CMDs_WaitUsartAdr
    btfsc STATUS, C
    goto NewLoop
    ;
    ;   Usart      
    movlw 100
    call Usart_In_WDT
    btfsc STATUS, C
    goto NewLoop
    movwf ReadMMCSize
    ;    
    call MMC_Adr_KorrHC
    movlw 0x40;    SD -  "parameter error"
    JNZ CMD1_Read_Error
    ;
    call MMC_OnCS_WaitEndOfWrite    
    movlw CMD17_READ_SINGLE_BLOCK
    call MMC_Cmd
    andlw 0xff
    btfss STATUS, Z
    goto CMD1_Read_Error
    ;
    ;       
    call MMC_WaitResp_Long
    call Usart_Out
    sublw 0xfe;                0xfe,    ,  
    btfss STATUS, Z
    goto CMD1_OffMMC
    ;
    ;  0xfe -   : DATA, 2  CRC, 0x55
    ;
    call SPI_ReadByte;     ( SSP   )
    ;
CMD1_ReadUsart:
    ;     Usart    ReadMMCSize*2 
    movf ReadMMCSize, w
    movwf WaitST
CMD1_Loop:
    call SPI_ReadAndOut_Usart
    call SPI_ReadAndOut_Usart
    decfsz WaitST
    goto CMD1_Loop
    ;
    call CMD5_SkipData
    ;
    movf ReadMMCSize, w
    JZ CMD1_SendCRC
    ; 
    call SPI_ReadByte;    2  CRC (  ,  )
    ;
    movlw 0xaa       ;       ( CRC )       
    call Usart_Out
    movlw 0x79
    call Usart_Out
    goto CMD1_OffMMC
    ;
CMD1_SendCRC:
    ;          CRC
    call SPI_ReadAndOut_Usart
    call SPI_ReadAndOut_Usart
    goto CMD1_OffMMC
    ;
CMD1_Read_Error:    
    andlw 0x7f
    call Usart_Out
CMD1_OffMMC:
    call MMC_OffCS
    goto NewLoop
    ;
    ;
    ;
    ;    ,    
    ;  :  ,  /2,    (0-usart57600  k-115200*k)
    ; : 0x53,  R1   SD,   ,    
    ;         STOP
    ;      0xTT,  T -  115200,    
    ;    ,    STOP      
    ;         STOP
    ;           Usart,
    ;    ( R1)      STOP.
    ;  STOP    (  ),  ,
    ;      
    ;   - 0xfe, , CRC.   0xfe,     
    ;       1 ,     0x99, 0xaa, 0x12, 0x55
    ;
CMD5:
    bcf INTCON, GIE
    ;
    ;   Usart 4     
    call CMDs_WaitUsartAdr
    btfsc STATUS, C
    goto NewLoop
    ;
    ;   Usart      
    movlw 200
    call Usart_In_WDT
    btfsc STATUS, C
    goto NewLoop
    movwf ReadMMCSize
    ; 
    ;   Usart    
    movlw 200
    call Usart_In_WDT
    btfsc STATUS, C
    goto NewLoop
    movwf ReadMMCSpeed
    ;
    movlw 0x53
    call Usart_Out
    ;
    call MMC_Adr_KorrHC 
    JZ CMD5_AdrOK
    movlw 0x40
    call Usart_Out;   SD- = parametr error
    goto NewLoop;
    ;   
CMD5_AdrOK:
    call MMC_OnCS_WaitEndOfWrite    
    movlw CMD18_READ_MULTY_BLOCK
    call MMC_Cmd
    call Usart_Out
    addlw 0
    btfss STATUS, Z
    goto CMD5_OffMMC;     -    ,  SD     
    ;
    call GetFastOutCode  ;   ReadMMCSpeed        
    movwf ReadMMCSpeed   ;            115200 ( ,   )
    call Usart_Out       ;      (0- , 0x88, 0x77, 0x44)    
    ;
    movf ReadMMCSpeed, w
    btfsc STATUS, Z
    goto CMD5_NoChangeSpeed
    ;
    ;    Usart     
    ;
    call EnableFastOut
    ;
    movlw 50          ;   1  (      
    movwf WaitST      ;     -,   Usart)
CMD5_Fast_StartWait:
    movlw 200
    call Delay1
    decfsz WaitST
    goto CMD5_Fast_StartWait
    ;
    ;
    movlw 0x99;
    call FastOut      ;    (    )      
    movlw 0xaa
    call FastOut
    movlw 0x12
    call FastOut
    movlw 0x55
    call FastOut
    ;
CMD5_NoChangeSpeed:
CMD5_Fast_Loop:
    clrwdt
    call TestStopCommand
    btfsc STATUS, Z
    goto CMD5_Exit
    call MMC_WaitResp_Long   ;       
    ;call SPI_ReadByte
    movwf WaitST
    ;addlw -0xff
    ;JZ CMD5_Fast_Loop
    ;movf WaitST, w
    call FastOut             ;   SD (   ReadMMCSpeed)
    movf WaitST, w
    sublw 0xfe               ;   0xfe,    ,  
    btfsc STATUS, Z
    goto CMD5_Fast_Data
    ;
    ;
CMD5_Exit:
    call DisableFastOut
    ;
    movlw 200                ;  20 ,    -    
    call Delay1
    ;
    movlw CMD12_STOPREAD     ;        
    call MMC_Cmd 
    call Usart_Out           ;   R1 
    call MMC_OffCS
    goto EnterNewLoop
    ;
CMD5_OffMMC:
    call MMC_OffCS
    goto NewLoop
    ;
CMD5_Fast_Data:
    ;  0xfe -   : DATA, 2  CRC, 0x55
    ;
    call SPI_ReadByte;     (SSP  )
    ;
    ; fast   (  ReadMMCSpeed)
    movf ReadMMCSize, w
    call ReadBlockSPI_And_FastOut
    movf ReadMMCSize, w
    call ReadBlockSPI_And_FastOut
    call CMD5_SkipData
    movlw 2;   CRC
    call ReadBlockSPI_And_FastOut
    ;
    goto CMD5_Fast_Loop
    ;
    ;
    ;
CMD5_SkipData:            ;           
    movf ReadMMCSize, w      
    sublw 0; w := 0 - w
    btfsc STATUS, Z
    return
    movwf WaitST
CMD5_SkipData_Loop:
    movlw 0xff
    movwf SSPBUF
    call WAIT4T;    8   SSPBUF ( 9)
    call WAIT4T
    movwf SSPBUF
    call WAIT4T
    decfsz WaitST
    goto CMD5_SkipData_Loop
    return
    ;
    ;
    ;  MMC_Adr  HC SD:  ,  Z=1 
    ;
MMC_Adr_KorrHC:
    bsf STATUS, Z
    btfsc MMC_Init_Status, MMCINIT_HC
    return
    ;    
    ;    HC -  MMC_Adr      
    ;
    movf MMC_Adr+3, w
    btfss STATUS, Z
    return
    bcf STATUS, Z
    btfsc MMC_Adr+2, 7
    return
    ;
    movf MMC_Adr+2, w
    movwf MMC_Adr+3
    movf MMC_Adr+1, w
    movwf MMC_Adr+2
    movf MMC_Adr+0, w
    movwf MMC_Adr+1
    ;
    bcf STATUS, C
    rlf MMC_Adr+1
    rlf MMC_Adr+2
    rlf MMC_Adr+3    
    ;
    clrf MMC_Adr
    return    
    ;
    ;
    ;
    ;
    ;
    ; 
    ;  FILL      
CMD2:
    ;   Usart 4    (Fill)  
    call CMDs_WaitUsartAdr
    btfsc STATUS, C
    goto NewLoop
    ;
    ;   Usart    
    movlw 200
    call Usart_In_WDT
    btfsc STATUS, C
    goto NewLoop
    movwf ReadMMCSize
    ;
    call MMC_OnCS_WaitEndOfWrite    
    movlw 0x58;        
    call MMC_Cmd
    call Usart_Out
    addlw 0
    btfss STATUS, Z
    goto CMD2_Write_Error
    ;
    call SPI_ReadByte;     
    ;
    ;     
    movlw 0xfe
    call SPI_OutByte
    clrf WaitST
CMD2_Loop:
    movf ReadMMCSize, w
    ;incf ReadMMCSize
    call SPI_OutByte
    movf ReadMMCSize, w
    ;incf ReadMMCSize
    call SPI_OutByte
    decfsz WaitST
    goto CMD2_Loop    
    ;
    call SPI_ReadByte;    - CRC
    call SPI_ReadByte
    ;
    call SPI_ReadByte;        
    ;movwf ReadMMCSize
    call Usart_Out
    ;
    ;call SPI_ReadByte;      
    ;
    ;call MMC_WaitEndOfWrite
    ;
    ;call MMC_WaitForWriteEnd
    ;
    ;movf ReadMMCSize, w
    ;call Usart_Out
    ;
    ; ,   
    call MMC_OffCS;   (CS:=1)    ;
    ;movlw 0x55
    ;call Usart_Out
    goto NewLoop
    ;
CMD2_Write_Error:    
    call MMC_OffCS
    movlw 0xee
    call Usart_Out
    goto NewLoop
    ;
    ;
    ;        
CMD4:
    ;   Usart 4      
    call CMDs_WaitUsartAdr
    btfsc STATUS, C
    goto NewLoop
    ;
    call MMC_OnCS_WaitEndOfWrite    
    movlw 0x58;        
    call MMC_Cmd
    call Usart_Out
    addlw 0
    btfss STATUS, Z
    goto CMD4_Write_Error
    ;
    call SPI_ReadByte;     
    ;
    ;     
    movlw 0xfe
    call SPI_OutByte
    clrf WaitST
CMD4_Loop:
    movlw 100
    call Usart_In_WDT
    call SPI_OutByte
    movlw 100
    call Usart_In_WDT
    call SPI_OutByte
    decfsz WaitST
    goto CMD4_Loop    
    ;
    call SPI_ReadByte;    - CRC
    call SPI_ReadByte
    ;
    call SPI_ReadByte;        
    call Usart_Out
    ;
    ; ,   
    call MMC_OffCS;   (CS:=1)    ;
    goto NewLoop
    ;
CMD4_Write_Error:    
    call MMC_OffCS
    movlw 0xee
    call Usart_Out
    goto NewLoop
    ;
    ; 
    ;
    ; ,   Usart -      ( ,   Z = 1)
    ;            
    ;
TestStopCommand:
    btfsc RCSTA, OERR
    call Usart_In_Reset
    movf RCREG, w
    sublw 0xcd
    btfss STATUS, Z
    return
    movf RCREG, w
    movwf FSR
    sublw 11
    btfsc STATUS, Z
    return;  ,   Z=1
    ;
    movf FSR, w
    sublw 0x50
    btfsc STATUS, Z
    goto TestStopCommand_50_AN0
    ;
    movf FSR, w
    sublw 0x51
    btfsc STATUS, Z
    goto TestStopCommand_51_AN1
    ;
    movf FSR, w
    sublw 0x52
    btfsc STATUS, Z
    goto TestStopCommand_52_NoRef
    ;
    movf FSR, w
    sublw 0x53
    btfsc STATUS, Z
    goto TestStopCommand_53_Ref12
    ;
    movf FSR, w
    sublw 0x54
    btfsc STATUS, Z
    goto TestStopCommand_54_Ref1
    ;
    movf FSR, w
    sublw 0x55
    btfsc STATUS, Z
    goto TestStopCommand_55_NakOn
    ;
    movf FSR, w
    sublw 0x56
    btfsc STATUS, Z
    goto TestStopCommand_56_NakOff
    ;
TestStopCommand_Exit:
    bcf STATUS, Z
    return;    ,   Z=0
    ;    
    ;
TestStopCommand_50_AN0:
    bcf ADCON0, 3
    bcf ADCON0, 4
    bcf ADCON0, 5
TestStopCommand_MyEnd:
    movf FSR, w
    call Usart_Out
    goto TestStopCommand_Exit    
TestStopCommand_51_AN1:
    bsf ADCON0, 3
    bcf ADCON0, 4
    bcf ADCON0, 5
    goto TestStopCommand_MyEnd    
TestStopCommand_52_NoRef:
    bsf STATUS, RP0
    movlw b'10000100'; D5 A3 D2 A1 A0
    ;movlw b'10000000'; A5 A3 A2 A1 A0 -  ,  
    movwf ADCON1; D7 -  , D6-4 - , D3-0 -  /
    bcf STATUS, RP0
    goto TestStopCommand_MyEnd    
TestStopCommand_53_Ref12:
    bsf STATUS, RP0
    movlw b'10001101'; D5 Vref+ Vref- A1 A0
    ;movlw b'10001000'; A5 Vref+ Vref- A1 A0 -  , A2  A3 
    movwf ADCON1
    bcf STATUS, RP0
    goto TestStopCommand_MyEnd    
TestStopCommand_54_Ref1:
    bsf STATUS, RP0
    movlw b'10000101'; D5 Vref+ D2 A1 A0
    ;movlw b'10000001'; A5 Vref+ A2 A1 A0 -  , A3 
    movwf ADCON1
    bcf STATUS, RP0
    goto TestStopCommand_MyEnd    
TestStopCommand_55_NakOn:
    clrf NakMode
    goto TestStopCommand_MyEnd    
TestStopCommand_56_NakOff:
    bsf NakMode, 0
    goto TestStopCommand_MyEnd    
    ;
StopCommandSendUsart:   ;   Usart     Stop
    movlw 0x5e
    call Usart_Out
    movlw 0x44
    call Usart_Out
    movlw 0xe7
    call Usart_Out
    movlw 0x23
    goto Usart_Out    
    ;
    ;
    ;
CMDE_ReadEmptyPos:      ;      
    movlw 0x71
    call Usart_Out
    call ReadEmptyPosFromEEPROM
    movf EmptyPos, w
    call Usart_Out
    movf EmptyPos+1, w
    call Usart_Out
    movf EmptyPos+2, w
    call Usart_Out
    movf EmptyPos+3, w
    call Usart_Out
    goto NewLoop
    ;
CMDE_WriteEmptyPos:     ;      
    call CMDs_WaitUsartAdr    
    btfsc STATUS, C
    goto NewLoop
    ;
    EmptyPosCoderM EmptyPosCode, MMC_Adr
    ;
    call CMDs_WaitUsartAdr    
    btfsc STATUS, C
    goto NewLoop
    ;
    XORL32M MMC_Adr, 0xa1e8bdca
    CMP32M MMC_Adr, EmptyPosCode
    btfss STATUS, Z
    goto NewLoop
    ;
    movlw 0
    call Eeprom_Write_Set_EEADR
    movf EmptyPosCode+0, w
    call Eeprom_Write_EEADR_w
    movf EmptyPosCode+1, w
    call Eeprom_Write_EEADR_w
    movf EmptyPosCode+2, w
    call Eeprom_Write_EEADR_w
    movf EmptyPosCode+3, w
    call Eeprom_Write_EEADR_w     
    ;
    movlw 0x71
    call Usart_Out
    goto NewLoop
    ;
    ;
    ;
    ;   EEPROM  EmptyPosCode     EmptyPos
    ;
ReadEmptyPosFromEEPROM:
    movlw 0
    call Eeprom_Read_w
    movwf EmptyPosCode+0
    movlw 1
    call Eeprom_Read_w
    movwf EmptyPosCode+1
    movlw 2
    call Eeprom_Read_w
    movwf EmptyPosCode+2
    movlw 3
    call Eeprom_Read_w
    movwf EmptyPosCode+3
    ;
    MOVE32M EmptyPos, EmptyPosCode    
    ;
    movlw EmptyPos+4;  EmptyPos
    movwf FSR
    movlw 8*4
    movwf WaitST
    bcf STATUS, C
ReadEmptyPosDecode1:
    movf WaitST, w
    andlw 7
    btfsc STATUS, Z
    decf FSR
    movlw 0x80
    btfsc STATUS, C
    xorwf INDF
    rlf INDF, w
    rlf INDF
    decfsz WaitST
    goto ReadEmptyPosDecode1
    ;
    ;  EmptyPos  FILE_GRANULA. : -     EEPROM 
    ;       
    ;
    movlw 0xff - (FILE_GRANULA-1) 
    andwf EmptyPos+0              
    return
    ;
    ;
    ;
    ;
    ;  SD - .     Usart:
    ;   0x57, (  CMD0)-1,     ,  
    ;     CMD8: R1 + 4  (R1==1,  )
    ;    R1  CMD1,   ,  
    ;   ( ),   CMD58_READ_OCR: R1+4  (R1==0,  ).
    ;        MMC_Init_Status.
    ;
MMC_Init:         
    movlw 0x57
    call Usart_Out
    clrf MMC_Init_Status
    call MMC_OffCS;   (CS:=1)
    movlw 20
    call Delay1   ;  2 
    clrf FSR      ;   256    
MMC_Init_L1:   
    call SPI_ReadByte
    decfsz FSR
    goto MMC_Init_L1
    movlw 20
    call Delay1;     2     
    call MMC_OnCS;        
    movlw 200;         CMD0      
    movwf WaitST    
MMC_Init_L11:
    clrwdt; !!!
    movlw 50
    call Delay1;        5         
    call SPI_ReadByte;   0xff   
    clrf MMC_Adr
    clrf MMC_Adr+1
    clrf MMC_Adr+2
    clrf MMC_Adr+3
    movlw CMD0_GO_IDLE_STATE;     CMD0
    call MMC_Cmd
    addlw -1
    btfsc STATUS, Z
    goto MMC_Init_L2;     1 (in idle state),    ,    L2
    decfsz WaitST
    goto MMC_Init_L11;       CMD0
    ; ,       CMD0
    call Usart_Out
MMC_Init_Exit:
    call MMC_OffCS
    movf MMC_Init_Status, w
    goto Usart_Out
    ;
MMC_Init_L2:
    call Usart_Out
    call SPI_ReadByte;   0xff   
    ;
    movlw CMD8_SEND_IF_COND;  HC:   CMD8 -      CRC
    call SPI_OutByte
    movlw 0
    call SPI_OutByte
    movlw 0
    call SPI_OutByte
    movlw 1
    call SPI_OutByte
    movlw 0xaa
    call SPI_OutByte
    movlw 0x87
    call MMC_Cmd_SendCRC
    call Usart_Out
    sublw 1          ;  CMD8 ,   1,     >= 2.0 SD Card
    movwf WaitST 
    call SPI_ReadByte;       CMD8      
    call Usart_Out
    iorwf WaitST
    call SPI_ReadByte
    call Usart_Out
    iorwf WaitST
    call SPI_ReadByte
    call Usart_Out
    sublw 1
    iorwf WaitST
    call SPI_ReadByte
    call Usart_Out
    sublw 0xaa
    iorwf WaitST, w
    btfsc STATUS, Z
    bsf MMC_Init_Status, MMCINIT_SD2; ,   SD >= 2.0
    ;
    ;   CMD1  ACMD41   ,   SD/  
    movlw 200  
    movwf WaitST
MMC_Init_L21:
    clrwdt; !!!
    movlw 50
    call Delay1;        5             
    ;call SPI_ReadByte;   0xff   
    ;movlw 0x41
    ;call MMC_Cmd;     CMD1
    ;movwf FSR
    ;;call Usart_Out
    ;sublw 0
    ;btfsc STATUS, Z
    ;goto MMC_Init_L3;   0 - ,    
    ;
    ;
    call SPI_ReadByte;   0xff       
    movlw CMD55_APP_CMD
    call MMC_Cmd
    andlw 0xff-1
    btfss STATUS, Z
    goto MMC_Init_L23;  ,   CMD55  
    ;
    btfsc MMC_Init_Status, MMCINIT_SD2
    bsf MMC_Adr+3, 6;   SD>=2.0,    HCS (D30,     HC)    
    ;
    call SPI_ReadByte;   0xff   
    movlw ACMD41_SD_SEND_OP_COND
    call MMC_Cmd
    addlw 0
    btfsc STATUS, Z
    goto MMC_Init_L3;   0 - ,    
MMC_Init_L23:
    ;
    clrf MMC_Adr+3;        HC
    call SPI_ReadByte;   0xff       
    movlw CMD55_APP_CMD
    call MMC_Cmd
    andlw 0xff-1
    btfss STATUS, Z
    goto MMC_Init_L22;  ,   CMD55  
    ;
    call SPI_ReadByte;   0xff   
    movlw ACMD41_SD_SEND_OP_COND
    call MMC_Cmd
    addlw 0
    btfsc STATUS, Z
    goto MMC_Init_L3;   0 - ,    
    ;
MMC_Init_L22:    
    decfsz WaitST
    goto MMC_Init_L21
    ; ,       
    call Usart_Out
    goto MMC_Init_Exit
    ;
MMC_Init_L3:
    call Usart_Out
    ;
    bsf MMC_Init_Status, MMCINIT_INITOK; ***     ***
    ;
    call SPI_ReadByte    ;   0xff   
    movlw CMD58_READ_OCR ;  OCR,    30   SD HC
    call MMC_Cmd
    call Usart_Out
    movwf FSR
    ;
    call SPI_ReadByte ;    OCR (D30  ,   HC)
    call Usart_Out
    movf FSR, f       ;   R1:   ,   OCR  
    btfss STATUS, Z
    andlw 0
    andlw 0x40
    btfss STATUS, Z
    bsf MMC_Init_Status, MMCINIT_HC
    ;    
    call SPI_ReadByte
    call Usart_Out
    call SPI_ReadByte
    call Usart_Out
    call SPI_ReadByte
    call Usart_Out
    goto MMC_Init_Exit
    ;
    ;
    ;
MMC_OnCS:             ;     CS:=0
    bcf PORTA, 5
    goto SPI_ReadByte ;  1    CS (   )
    ;
MMC_OffCS:            ;     CS:=1
    call SPI_ReadByte ;      
    bsf PORTA, 5  
    goto SPI_ReadByte ;    ,    
    ;
    ;
MMC_Cmd:
    call SPI_OutByte;    
    movf MMC_Adr+3, w
    call SPI_OutByte;  4  
    movf MMC_Adr+2, w
    call SPI_OutByte
    movf MMC_Adr+1, w
    call SPI_OutByte
    movf MMC_Adr+0, w
    call SPI_OutByte
    movlw 0x95
MMC_Cmd_SendCRC:    
    call SPI_OutByte;     
    ;
MMC_WaitRespCmd:
    movlw 64
    ;
    ;     (  0xff )
    ;    w -   
MMC_WaitResp:    
    movwf FSR;        
MMC_Cmd_Wait:
    call SPI_ReadByte
    addlw -0xff 
    btfss STATUS, Z
    goto MMC_Cmd_Ret
    decfsz FSR
    goto MMC_Cmd_Wait
MMC_Cmd_Ret:
    addlw +0xff
    return
    ;
    ;
    ;     0xff   
    ;    w -    256   
    ;
MMC_WaitResp_Long:
    clrf WaitST
MMC_WaitResp_Long_L1:
    clrf FSR
MMC_WaitResp_Long_L2:
    call SPI_ReadByte
    addlw -0xff 
    btfss STATUS, Z
    goto MMC_WaitResp_Long_Ret
    decfsz FSR    
    goto MMC_WaitResp_Long_L2
    decfsz WaitST
    goto MMC_WaitResp_Long_L1
MMC_WaitResp_Long_Ret:
    addlw +0xff
    return;
    ;
    ;
    ;      
    ;
MMC_OnCS_WaitEndOfWrite:    
    call MMC_OnCS
    clrf WaitST
MMC_WaitEndOfWrite_L1:
    clrf FSR
MMC_WaitEndOfWrite_L2:
    call SPI_ReadByte    
    sublw 0
    btfss STATUS, Z   
    return
    decfsz FSR
    goto MMC_WaitEndOfWrite_L2
    decfsz WaitST
    goto MMC_WaitEndOfWrite_L1
    ;   ,    
    return
    ;
    ;
    ;
    ;    SPI
SPI_ReadByte:
    movlw 0xff
    ;    SPI    
SPI_OutByte:
    movwf SSPBUF
    bsf STATUS, RP0
SPI_OutByte_LL:
    btfss SSPSTAT, BF
    goto SPI_OutByte_LL
    bcf STATUS, RP0
    movf SSPBUF, w
    return
    ;
    ;
    ;
    ;
    ;     250  (0.1 ),  FSR 
Delay1:        
    movwf FSR
Delay1_L1:
    movlw 61
    nop
    nop    
Delay1_L2:
    addlw -1
    btfss STATUS, Z
    goto Delay1_L2
    decfsz FSR
    goto Delay1_L1
WAIT5T:
    nop
WAIT4T:
    return    
    ;
;SysTime_Update:
;    movf SysTime,w
;    subwf Shim_ST, w
;    addwf SysTime
;    btfss STATUS, C
;    return
;    incfsz SysTime+1
;    return         
;    incfsz SysTime+2
;    return
;    incf SysTime+3
;    return
    ; 
    ;   w -     
Eeprom_Read_w:
    bsf STATUS, RP1
    movwf EEADR
    bsf STATUS, RP0
    bcf EECON1, EEPGD
    bsf EECON1, RD
    bcf STATUS, RP0
    movf EEDATA, w
    bcf STATUS, RP1
    return
    ;
    ;
    ;  W  EEPROM   EEADR++:     , 
    ;    W   EEADR 
    ; (  EEDATA = W    ,    
    ;  Eeprom_Write_Set_EEADR   ,     )
    ;
Eeprom_Write_EEADR_w:
    bsf STATUS, RP0
    bsf STATUS, RP1
    btfsc EECON1, WR
    goto $-1
    bcf STATUS, RP0
    movwf EEDATA
    bsf STATUS, RP0
    bcf EECON1, EEPGD
    bsf EECON1, WREN
    bcf INTCON, GIE
    movlw 0x55
    movwf EECON2
    movlw 0xaa
    movwf EECON2
    bsf EECON1, WR
    bsf INTCON, GIE
    bcf EECON1, WREN
    btfsc EECON1, WR
    goto $-1
    bcf STATUS, RP0
    incf EEADR
    bcf STATUS, RP1
    return    
    ;
    ;
    ;  EEADR:=W,      
    ;
Eeprom_Write_Set_EEADR:
    bsf STATUS, RP1
    bsf STATUS, RP0
    btfsc EECON1, WR
    goto $-1
    bcf STATUS, RP0
    movwf EEADR
    bcf STATUS, RP1
    return    
    ;
    ; *********************************************************************
    ;
USER_CODE_IRQ:
    movwf IntProc_Temp1
    swapf IntProc_Temp1    
    swapf STATUS, w
    clrf STATUS
    movwf IntProc_Temp2
    ;
    btfsc INTCON, T0IF 
    goto IRQ_StartACP
    ;
    bcf PIR1, ADIF; ,      
    ;
    incfsz ACP_NNN
    goto IRQ_Not256
    ; 
    ;  ACP_NNN == 256,   -10
    movlw -10
    movwf ACP_NNN
    ;
    ;  D5-3 -   . 
    ;bcf ADCON0, 3;   ,         
    ;bsf ADCON0, 3;  AN1 ,       (12.01.2017)
    ;
    ;        CH2_N, CH2_Hi:CH2_Lo
    ;
    btfsc CH2_N,6
    goto IRQ_Exit
    ;
    bsf STATUS, RP0
    movf ADRESL, w
    bcf STATUS, RP0
    addwf CH2_Lo
    movf ADRESH, w
    btfsc STATUS, C
    incfsz ADRESH, w
    addwf CH2_Hi
    ;
    incf CH2_N
    goto IRQ_Exit
    ;
    ; 
    ;           
IRQ_Not256:
    ;
    btfsc NakMode, 0;   :  NakMode.D0=1,     
    clrf ACP_Sum
    btfsc NakMode, 0
    clrf ACP_Sum+1
    ;
    ;         ACP_Sum
    bsf STATUS, RP0
    movf ADRESL, w
    bcf STATUS, RP0
    addwf ACP_Sum+0
    movf ADRESH, w
    btfsc STATUS, C
    incfsz ADRESH, w
    addwf ACP_Sum+1 
    ;
    ;         ?  ,  
    incfsz ACP_NNN, w
    goto IRQ_Exit
    ;
    ;       (),   ,     
    ;      
    ;
    ; 2010.07.12+1 -      (  ):
    ;bsf ADCON0, 3;  CH2
    ;    
    ;  ,     
    ; 
    movf FSR, w
    movwf IntProc_FSR
    ;
    bcf ACP_BufPos, 0;   
    movf ACP_BufPos, w
    addlw -ACP_MemoryBuffer
    movf ACP_BufPos, w
    btfss STATUS, C
    movlw ACP_MemoryBuffer
    movwf FSR
    ;
    movf ACP_Sum, w
    movwf INDF    
    incf FSR
    movf ACP_Sum+1, w
    movwf INDF    
    incfsz FSR, w
    goto $+2
    movlw ACP_MemoryBuffer
    movwf ACP_BufPos
    ;
    movf IntProc_FSR, w
    movwf FSR    
    ;
    clrf ACP_Sum
    clrf ACP_Sum+1
    ;
IRQ_Exit:    
    swapf IntProc_Temp2, w
    movwf STATUS
    swapf IntProc_Temp1, w
    retfie
    ;
    ;
    ;
IRQ_StartACP:
    ;
    ;   
    bsf ADCON0, GO
    ;
    ;   
    INC32M SysTime
    ;
    bcf INTCON, T0IF;    .   0 
    ;
    ;goto IRQ_Exit
    ;
    ; 24.06.2009 -   TMR1     CCP
    ;
    btfss PIR1, CCP1IF
    goto Irq_NoLock
    ;
    movf CCPR1L, w
    movwf Locked_L
    movf CCPR1H, w
    movwf Locked_H
    bcf PIR1, CCP1IF
    btfss PIR1, TMR1IF
    goto Irq_Lock_NoTmr1
    ;     
    btfsc Locked_H, 7
    goto Irq_Lock_NoTmr1
    IRQINCTMR1HI
Irq_Lock_NoTmr1:
    ;
    ; ,   TMR1_B3:TMR1_B2:Locked_H:Locked_L
    ;  32-   
    ;
    btfss LockAct, 0    
    goto Irq_Act_AnyFront
    ;
    ;     
    ;
    MOVE32M NewLockRes_T0, NewLock_T0
    MOVE32M NewLockRes_S, NewLock_S
    MOVE32M NewLockRes_N, NewLock_N
    ;
    bcf LockAct, 0; ,   NewLockRes 
    ;
    MOVE32M NewLock_T0, Locked_Value
    CLR32M  NewLock_S
    CLR32M  NewLock_N    
    goto IRQ_Exit
    ;
Irq_Act_AnyFront:   ;    
    ADD32M NewLock_S, Locked_Value 
    ;SUB32M NewLock_S, NewLock_T0 
    INC32M NewLock_N; 
    goto IRQ_Exit
    ; 
    ;
Irq_NoLock:     ;      TMR1   
    btfss PIR1, TMR1IF
    goto IRQ_Exit
    IRQINCTMR1HI
    goto IRQ_Exit
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;
    ;     
    ;
MMA7455_Init:
    movlw 0x16;         Mode Control Register
    movwf DS1621_Cmd
    movlw b'00000101';   ,  2g
    movwf DS1621_Byte0
    call DS1621_Out2    
    ;
    movlw 0x18;         
    movwf DS1621_Cmd
    movlw b'00000000';      : 0 - 62.5 , 1 - 125 
    movwf DS1621_Byte0
    goto DS1621_Out2        
    ;
    ;
    ;    : XOUT8, YOUT8, ZOUT8
    ;    
MMA7455_Read8:
    movlw 6;         XOUT8,  YOUT8, ZOUT8
    movwf DS1621_Cmd
    goto DS1621_In3    
    ;
    ;
    ;  : D0 -  , D1 -  
    ;    
MMA7455_GetStatus:
    movlw 9;          Status Register 
    movwf DS1621_Cmd
    goto DS1621_In1    
    ;
    ;
    ;
    ;
    ;
Termo_Read:
    movlw b'10010010'
    movwf I2C_Adress
    clrf I2C_Error  
    clrf TH_Slope
    ;   
    movlw 0xAC
    movwf DS1621_Cmd
    call DS1621_In1
    movf DS1621_Byte0, w
    movwf TH_Config
    ;   
    movlw 0xAA
    movwf DS1621_Cmd
    call DS1621_In2
    movf DS1621_Byte0, w
    movwf TH_Temperature+0
    movf DS1621_Byte1, w
    movwf TH_Temperature+1
    ;   Counter
    movlw 0xA8
    movwf DS1621_Cmd
    call DS1621_In1
    movf DS1621_Byte0, w
    movwf TH_Counter
    movlw 0xA9
    movwf DS1621_Cmd
    call DS1621_In1
    movf DS1621_Byte0, w
    movwf TH_Slope
    ;
    btfss TH_Config, 7
    return
    ;     
    movlw 0xAC
    movwf DS1621_Cmd
    movlw b'00001000'
    movwf DS1621_Byte0
    call DS1621_Out2
    movlw 0xEE
    movwf DS1621_Cmd
    goto DS1621_Out1  
    ;
    ;
    ;
DS1621_Out1:
    call I2C_Start
    movf I2C_Adress, w
    call I2C_Out
    movf DS1621_Cmd, w 
    call I2C_Out
    goto I2C_Stop
    ;
DS1621_Out2:
    call I2C_Start
    movf I2C_Adress, w    
    call I2C_Out
    movf DS1621_Cmd, w 
    call I2C_Out
    movf DS1621_Byte0, w 
    call I2C_Out
    goto I2C_Stop
    ;
    ;
DS1621_Out3:
    call I2C_Start
    movf I2C_Adress, w
    call I2C_Out
    movf DS1621_Cmd, w 
    call I2C_Out
    movf DS1621_Byte0, w 
    call I2C_Out
    movf DS1621_Byte1, w 
    call I2C_Out
    goto I2C_Stop
    ;
    ;
    ;
DS1621_In1:
    call I2C_Start
    movf I2C_Adress, w    
    call I2C_Out
    movf DS1621_Cmd, w 
    call I2C_Out
    ;
    call I2C_RepStart;   
    movf I2C_Adress, w
    call I2C_OutOr1;      
    ;
    call I2C_Input
    call I2C_Input_NAsk
    movf I2C_DataByte, w
    movwf DS1621_Byte0
    goto I2C_Stop
    ;
DS1621_In2:
    call I2C_Start
    movf I2C_Adress, w    
    call I2C_Out
    movf DS1621_Cmd, w 
    call I2C_Out
    ;
    call I2C_RepStart;   
    movf I2C_Adress, w
    call I2C_OutOr1;       
    ;
    call I2C_Input
    call I2C_Input_Ask
    movf I2C_DataByte, w
    movwf DS1621_Byte0
    ;
    call I2C_Input
    call I2C_Input_NAsk
    movf I2C_DataByte, w
    movwf DS1621_Byte1
    goto I2C_Stop
    ;
DS1621_In3:
    call I2C_Start
    movf I2C_Adress, w    
    call I2C_Out
    movf DS1621_Cmd, w 
    call I2C_Out
    ;
    call I2C_RepStart;   
    movf I2C_Adress, w
    call I2C_OutOr1;       
    ;
    call I2C_Input
    call I2C_Input_Ask
    movf I2C_DataByte, w
    movwf DS1621_Byte0
    ;
    call I2C_Input
    call I2C_Input_Ask
    movf I2C_DataByte, w
    movwf DS1621_Byte1
    ;
    call I2C_Input
    call I2C_Input_NAsk
    movf I2C_DataByte, w
    movwf DS1621_Byte2
    ;
    goto I2C_Stop
    ;
    ;
    ;
    ;   
    ;
I2C_Start:
    call I2C_SCL_Hi
    call I2C_SDA_Hi
    call I2C_Wait
    call I2C_SDA_Lo
    goto I2C_Wait
    ;
I2C_Stop:
    call I2C_SCL_Lo
    call I2C_Wait
    call I2C_SDA_Lo
    call I2C_Wait
    call I2C_SCL_Hi
    call I2C_Wait
    call I2C_SDA_Hi
    goto I2C_Wait
    ;
I2C_RepStart:
    call I2C_SCL_Lo
    call I2C_Wait
    call I2C_SDA_Hi
    call I2C_Wait
    call I2C_SCL_Hi
    call I2C_Wait
    call I2C_SDA_Lo
    goto I2C_Wait
    ;
    ;
    ;
    ;
    ;
    ;           w     1    I2C  (  I2C-)
I2C_OutOr1:  
    iorlw 1
    ;
    ;           w -   I2C 
I2C_Out:  
    movwf I2C_DataByte
    movlw 9
    movwf I2C_OutBitST
    ;
I2C_Out_OutBit:
    call I2C_SCL_Lo
    call I2C_Wait
    ;
    rlf I2C_DataByte, w;         SDA    
    bsf STATUS, RP0;         
	btfsc STATUS, C
    bsf I2CTRIS, IC2DataBit
	btfss STATUS, C
    bcf I2CTRIS, IC2DataBit
    bcf STATUS, RP0	
    call I2C_Wait
    ;
    call I2C_SCL_Hi;            SCL  	
    call I2C_Wait
    ;
    ;   ,      
    bcf STATUS, C
    btfsc I2CPORT, IC2DataBit
    bsf STATUS, C
    rrf I2C_DataByte, w
    xorwf I2C_DataByte, w
    andlw 0x80
    btfss STATUS, Z
    goto I2C_Out_NoData
    ;
    ;    
    bsf STATUS, C
    rlf I2C_DataByte
    decfsz I2C_OutBitST
    goto I2C_Out_OutBit
    ; 
    ; ,  9-    , .. ACK 
    bsf I2C_Error, 0
    return;
    ;
    ;
I2C_Out_NoData:
    decfsz I2C_OutBitST
    goto I2C_Out_Error
    ; ,   
    return
    ;
I2C_Out_Error:
    ;  ,      
    bsf I2C_Error, 1
    return;
    ;
    ;
I2C_Input:
    movlw 8
    movwf I2C_OutBitST
    ;
I2C_Input_InBit:
    call I2C_SCL_Lo;         
    call I2C_Wait
    call I2C_SDA_Hi;         
    call I2C_Wait
    call I2C_SCL_Hi;         
    call I2C_Wait
    ;
    bcf STATUS, C;             
    btfsc I2CPORT, IC2DataBit
    bsf STATUS, C
    rlf I2C_DataByte
    ;
    decfsz I2C_OutBitST
    goto I2C_Input_InBit
    ;
    movf I2C_DataByte, w
    return
    ;
    ;    
I2C_Input_Ask:
    call I2C_SCL_Lo
    call I2C_Wait
    call I2C_SDA_Lo
    call I2C_Wait
    call I2C_SCL_Hi
    goto I2C_Wait
    ;
I2C_Input_NAsk:
    call I2C_SCL_Lo
    call I2C_Wait
    call I2C_SDA_Hi
    call I2C_Wait
    call I2C_SCL_Hi
    goto I2C_Wait
    ;
    ;
I2C_SCL_Lo:
    bsf STATUS, RP0;            SCL
	bcf I2CTRIS, IC2SyncBit
    bcf STATUS, RP0	
    return
I2C_SCL_Hi:
    bsf STATUS, RP0;            SCL
	bsf I2CTRIS, IC2SyncBit
    bcf STATUS, RP0	
    return
I2C_SDA_Lo:
    bsf STATUS, RP0	
	bcf I2CTRIS, IC2DataBit
	bcf STATUS, RP0
    return	
I2C_SDA_Hi:
    bsf STATUS, RP0	
	bsf I2CTRIS, IC2DataBit
	bcf STATUS, RP0
    return	
    ;
    ;
I2C_Wait:
    movlw 2
I2C_Wait_L1: 
    addlw -1
    btfss STATUS, Z
    goto I2C_Wait_L1
    return
    ;
    ;
    ;
    ;
Usart_In_Reset:
    bcf RCSTA, CREN
    bsf RCSTA, CREN
    return

    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ;
MMA7455_ReadDataLoop:
    clrf I2C_Error  
    clrwdt
    ;
    call MMA7455_Init
    ;
    call MMA7455_GetStatus
    btfss DS1621_Byte0, 0
    goto MMA7455_ReadDataLoop
    ;
    call MMA7455_Read8    
    ;
    movlw 0xeb
    call Usart_Out
    movlw 0x77
    call Usart_Out
    movf DS1621_Byte0, w
    call Usart_Out
    movf DS1621_Byte1, w
    call Usart_Out
    movf DS1621_Byte2, w
    call Usart_Out
    movf I2C_Error, w
    call Usart_Out
    ;
    goto MMA7455_ReadDataLoop
    ;
    ;
    ;
    ;
    ;
    ;
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ; ********************************************************************************************
    ;      RS-232
    ;    Usart (57600 ),  Fast:    RC0 
    ;
    ;
EnableFastOut:          ;  Fast -  (  )
    bsf STATUS, RP0
    btfss TXSTA, TRMT   ; ,      Usart ( -)
    goto $-1
    bcf STATUS, RP0
    ;
    bcf INTCON, GIE     ;  
    bsf PORTC, 0        ;    RC0 (  ,  -)
    bsf STATUS, RP0     
    bcf TRISC, 0
    bcf STATUS, RP0
    ;
    bsf STATUS, RP0     ;  ,  RC6   
    bsf TRISC, 6
    bcf TXSTA, TXEN
    bcf STATUS, RP0
    return
    ;
DisableFastOut:
    bsf STATUS, RP0     ;  
    bsf TXSTA, TXEN
    bcf STATUS, RP0
    ;
    bsf STATUS, RP0     ;  fast    ,    Usart
    bsf TRISC, 0
    bcf STATUS, RP0
    return
    ;
    ;
    ;
    ;    ,  ReadMMCSpeed
    ;     FastOut  ReadBlockSPI_And_FastOut
    ;
GetFastOutCode:
    btfsc ReadMMCSpeed, 3
    retlw 0x88               ; 921600 = 115200*8  ReadMMCSpeed == 8
    btfsc ReadMMCSpeed, 1
    retlw 0x77               ; 806400 = 115200*7  ReadMMCSpeed == 7
    btfsc ReadMMCSpeed, 2
    retlw 0x44               ; 460800 = 115200*4  ReadMMCSpeed == 4
    retlw 0x00
    ;
    ;
    ;   W   Usart,   Fast (RC0)    ReadMMCSpeed
    ;
FastOut:
    btfsc ReadMMCSpeed, 3
    goto FastOut921600Proc   ; 921600 = 115200*8  ReadMMCSpeed == 8
    btfsc ReadMMCSpeed, 1
    goto FastOut806400Proc   ; 806400 = 115200*7  ReadMMCSpeed == 7
    btfsc ReadMMCSpeed, 2
    goto FastOut460800Proc   ; 460800 = 115200*4  ReadMMCSpeed == 4
    goto Usart_Out           ;     Usart  ReadMMCSpeed == 0
    ;
    ;
    ;    W  SPI   Usart,   Fast (RC0)
    ;
ReadBlockSPI_And_FastOut:
    movwf WaitST
    btfsc ReadMMCSpeed, 3
    goto ReadBlockSPI_And_FastOut921600L   ; 921600 = 115200*8  ReadMMCSpeed == 8
    btfsc ReadMMCSpeed, 1
    goto ReadBlockSPI_And_FastOut806400L   ; 806400 = 115200*7  ReadMMCSpeed == 7
    btfsc ReadMMCSpeed, 2
    goto ReadBlockSPI_And_FastOut460800L   ; 460800 = 115200*4  ReadMMCSpeed == 4
    ;
    ;     Usart  ReadMMCSpeed == 0
    ;
ReadBlockSPI_And_FastOutUSART_L:
    call SPI_ReadAndOut_Usart
    decfsz WaitST
    goto ReadBlockSPI_And_FastOutUSART_L
    return
    ;    
    ;
    ;
FastOut921600Proc:               ;  : 3,2,3,3,3,2,3,3,2,3
    bcf PORTC, 0
    movwf FSR
    rrf FSR 
    rlf PORTC
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    bsf PORTC, 0    
    return
    ;
    ;
FastOut806400Proc:              ;  : 3,3,3,3,4,3,3,3,3,3
    bcf PORTC, 0
    movwf FSR    
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    nop
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    nop
    bsf PORTC, 0    
    return
    ;
FastOut460800Proc:             ;  : 5,6,5,6,5,6,5,5,6,5
    bcf PORTC, 0
    movwf FSR        
    ;nop
    WAIT2; nop
    rrf FSR 
    rlf PORTC
    ;nop
    ;nop
    ;nop
    WAIT4; nop
    rrf FSR 
    rlf PORTC
    ;nop
    ;nop
    WAIT3; nop
    rrf FSR 
    rlf PORTC
    ;nop
    ;nop
    ;nop
    WAIT4; nop
    rrf FSR 
    rlf PORTC
    ;nop
    ;nop
    WAIT3; nop
    rrf FSR 
    rlf PORTC
    ;nop
    ;nop
    ;nop
    WAIT4; nop
    rrf FSR 
    rlf PORTC
    ;nop
    ;nop
    WAIT3; nop
    rrf FSR 
    rlf PORTC
    ;nop
    ;nop
    WAIT3; nop
    rrf FSR 
    rlf PORTC
    ;nop
    ;nop
    ;nop
    ;nop
    WAIT5; nop
    bsf PORTC, 0    
    ;nop
    WAIT2; nop    
    return
    ;
    ;
    ;
    ;       SPI     Fast (RC0)
    ;    WaitST
    ; ,   SSPBUF      ,      
    ; 8 ( 9)    SSPBUF: = 0xff
    ;
ReadBlockSPI_And_FastOut806400L:
    bcf PORTC, 0
    rrf SSPBUF, w
    movwf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    movlw 0xff;        SPI
    movwf  SSPBUF
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    nop
    bsf PORTC, 0    
    decfsz WaitST
    goto ReadBlockSPI_And_FastOut806400L
    return
    ;
    ;
ReadBlockSPI_And_FastOut921600L:
    bcf PORTC, 0
    rrf SSPBUF, w
    movwf FSR 
    rlf PORTC
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    movlw 0xff
    rrf FSR 
    rlf PORTC
    movwf  SSPBUF
    rrf FSR 
    rlf PORTC
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    rrf FSR 
    rlf PORTC
    nop
    bsf PORTC, 0    
    decfsz WaitST
    goto ReadBlockSPI_And_FastOut921600L
    return
    ;
ReadBlockSPI_And_FastOut460800L:
    bcf PORTC, 0
    movwf FSR        
    nop
    rrf SSPBUF, w
    movwf FSR 
    rlf PORTC
    ;nop
    ;nop
    ;nop
    WAIT4; nop
    rrf FSR 
    rlf PORTC
    ;nop
    ;nop
    WAIT3; nop
    rrf FSR 
    rlf PORTC
    ;nop
    ;nop
    ;nop
    WAIT4; nop
    rrf FSR 
    rlf PORTC
    nop
    movlw 0xff
    movwf SSPBUF
    rrf FSR 
    rlf PORTC
    ;nop
    ;nop
    ;nop
    WAIT4; nop
    rrf FSR 
    rlf PORTC
    ;nop
    ;nop
    WAIT3; nop
    rrf FSR 
    rlf PORTC
    ;nop
    ;nop
    WAIT3; nop
    rrf FSR 
    rlf PORTC
    ;nop
    ;nop
    ;nop
    ;nop
    WAIT5; nop
    bsf PORTC, 0    
    nop    
    decfsz WaitST
    goto ReadBlockSPI_And_FastOut460800L
    return
    ;
    ;
    ;
SPI_ReadAndOut_Usart:
    movf SSPBUF, w
    movwf FSR
    movlw 0xff
    movwf SSPBUF
    movf FSR, w
    goto Usart_Out ;    - Usart_Out       8 
    ;
    ;
    END 

